<?php

/**
 * @file
 * Owner or admin views handler filter.
 */

/**
 * Filter view results by a combination of entity owner and logged-in user
 * permissions.
 */
class owner_or_admin_views_handler_filter extends views_handler_filter {

  /**
   * Make sure we don't have an admin summary.
   */
  public function admin_summary() {}

  /**
   * Make sure we don't expose an operator form.
   */
  public function operator_form(&$form, &$form_state) {}

  /**
   * Make sure we don't allow users to expose this filter.
   */
  public function can_expose() {
    return FALSE;
  }

  /**
   * Add where expression to the query to filter the content based on ownership
   * of the content or on the administer nodes permission.
   */
  public function query() {
    $table = $this->ensure_my_table();
    $this->query->add_where_expression($this->options['group'], "($table.uid = ***CURRENT_USER*** AND ***CURRENT_USER*** <> 0) OR ***ADMINISTER_NODES*** = 1");
  }

}
